/**
 *  @file   mbstr.c
 *  @brief  shift-jis p mbstring֌W[`
 *  @author tenk@6809.net
 */

#include <stddef.h>
#include "mbstr.h"

/** MultiBytesrc̏I[當 key T.
 */
unsigned char *_mbsrchr(const unsigned char *src, unsigned int key)
{
    const unsigned char *s;
    const unsigned char *t;
    int   c, k;

    k = key;
    t = NULL;
    s = (const unsigned char *)src;
    if (key < 0x100) {
        while ((c = *s) != '\0') {
            if (_ismbblead(c)) {
                if (s[1] == '\0')
                    break;
                s++;
            } else if (c == k) {
                t = s;
            }
            s++;
        }
    } else {
        while ((c = *s) != '\0') {
            if (_ismbblead(c)) {
                if (s[1] == '\0')
                    break;
                c = (c << 8) | s[1];
                if (c == k)
                    t = s;
                s++;
            }
            s++;
        }

    }
    return (char *)t;
}

